'       Semi-Active Time RPG Battle Engine for Qbasic/QuickBasic4.5/PDS
'
'       Program and graphics by: DarkDread
'
'       Created: August 11-13th, 1999
'
'       You may use this code in your own game... and you may also use the
'       graphics provided with this code.  You must, however, give the author,
'       DarkDread, credit in your programs.
'
'       Contact: darkdread@hotmail.com
'       Website: http://www.geocities.com/TimesSquare/Ring/1683/index.html
'

'$DYNAMIC
DEFINT A-Z

DECLARE SUB GetHandLocation ()
DECLARE SUB TimerDelay (Seconds!)
DECLARE SUB Battle ()
DECLARE SUB StatsBox ()
DECLARE SUB ChoiceBox (BoxType%)
DECLARE SUB DrawBattleScreen (ScreenType%)
DECLARE SUB InitBattle ()
DECLARE SUB InitRandomStats ()
DECLARE SUB InitSprites ()

CONST True = -1, False = NOT True

DIM SHARED Hand%(258)
DIM SHARED Players%(4626)
DIM SHARED Enemies%(2570)
DIM SHARED BackSprite%(1028)
DIM SHARED BackHand%(129)

DIM SHARED PlayerName$(1 TO 2), PlayerAlive%(1 TO 2), PlayerType%(1 TO 2)
DIM SHARED PlayerHP%(1 TO 2), PlayerMaxHP%(1 TO 2), PlayerMP%(1 TO 2), PlayerMaxMP%(1 TO 2)
DIM SHARED PlayerST%(1 TO 2), PlayerDF%(1 TO 2), PlayerAG%(1 TO 2)
DIM SHARED PlayerMS%(1 TO 2), PlayerMD%(1 TO 2)
DIM SHARED PlayerEXP&(1 TO 2), PlayerGold&
DIM SHARED PlayerX%(1 TO 2), PlayerY%(1 TO 2), PlayerGo%(1 TO 2)

DIM SHARED EnemyName$(1 TO 4), EnemyAlive%(1 TO 4), EnemyType%(1 TO 4)
DIM SHARED EnemyHP%(1 TO 4), EnemyMaxHP%(1 TO 4), EnemyMP%(1 TO 4), EnemyMaxMP%(1 TO 4)
DIM SHARED EnemyST%(1 TO 4), EnemyDF%(1 TO 4), EnemyAG%(1 TO 4)
DIM SHARED EnemyMS%(1 TO 4), EnemyMD%(1 TO 4)
DIM SHARED EnemyEXP%(1 TO 4), EnemyGold%(1 TO 4)
DIM SHARED EnemyX%(1 TO 4), EnemyY%(1 TO 4), EnemyGo%(1 TO 4)

DIM SHARED HandX%, HandY%, EnemyThere%

RANDOMIZE TIMER

InitSprites
InitRandomStats

SCREEN 13

Battle

REM $STATIC
SUB Battle

    InitBattle
    DrawBattleScreen 1
    DO

        DO

            FOR I = 1 TO 4
                IF EnemyAlive%(I) THEN EnemyGo%(I) = EnemyGo%(I) + EnemyAG%(I)
                IF EnemyGo%(I) > 99 THEN
                    EnemyGo%(I) = -1: GoThere% = True
                END IF
                IF EnemyGo%(I) = -1 THEN EXIT FOR
            NEXT I
            FOR I = 1 TO 2
                IF PlayerAlive%(I) THEN PlayerGo%(I) = PlayerGo%(I) + PlayerAG%(I)
                IF I = 1 THEN
                        Yellow = PlayerGo%(I) + 128
                        IF Yellow% > 228 THEN Yellow% = 228
                        IF Yellow% > 128 THEN LINE (128, 16)-(Yellow%, 18), 44, BF
                        IF Yellow% < 228 THEN LINE (Yellow% + 1, 16)-(228, 18), 40, BF
                    ELSEIF I = 2 THEN
                        Yellow = PlayerGo%(I) + 128
                        IF Yellow% > 228 THEN Yellow% = 228
                        IF Yellow% > 128 THEN LINE (128, 32)-(Yellow%, 34), 44, BF
                        IF Yellow% < 228 THEN LINE (Yellow% + 1, 32)-(228, 34), 40, BF
                END IF
                IF PlayerGo%(I) > 99 THEN
                    GoGo% = True
                END IF
                IF PlayerGo%(I) > 99 THEN EXIT FOR
            NEXT I
            TimerDelay .1

        LOOP UNTIL GoThere% OR GoGo%

        IF GoThere% THEN
        FOR I = 1 TO 4
            IF EnemyGo%(I) = -1 AND EnemyAlive%(I) THEN
                PUT (EnemyX%(I), EnemyY%(I)), Enemies%(514 * 4), AND
                HitPlayer% = INT(RND * 2) + 1
                IF PlayerAlive%(HitPlayer%) THEN
                        Damage% = (EnemyST%(I) * 2 + (INT(RND * 4))) - PlayerDF%(HitPlayer%)
                        IF Damage% < 1 THEN Damage% = INT(RND * 2) + 1
                        PlayerHP%(HitPlayer%) = PlayerHP%(HitPlayer%) - Damage%
                        IF PlayerHP%(HitPlayer%) < 1 THEN
                                PlayerHP%(HitPlayer%) = 0: PlayerAlive%(HitPlayer%) = False
                        END IF
                    ELSE
                        IF HitPlayer% = 1 THEN HitPlayer% = 2 ELSE HitPlayer% = 1
                        Damage% = (EnemyST%(I) * 2 + (INT(RND * 4))) - PlayerDF%(HitPlayer%)
                        IF Damage% < 1 THEN Damage% = INT(RND * 2) + 1
                        PlayerHP%(HitPlayer%) = PlayerHP%(HitPlayer%) - Damage%
                        IF PlayerHP%(HitPlayer%) < 1 THEN
                                PlayerHP%(HitPlayer%) = 0: PlayerAlive%(HitPlayer%) = False
                        END IF
                END IF
                IF HitPlayer% = 1 THEN
                        LOCATE 12, 36: PRINT Damage%
                        TimerDelay 3
                    ELSEIF HitPlayer% = 2 THEN
                        LOCATE 18, 36: PRINT Damage%
                        TimerDelay 3
                END IF
                EnemyGo%(I) = 0: GoThere% = False: DrawNeed% = 1
            END IF
        NEXT I
        END IF
        IF DrawNeed% = 1 AND GoGo% THEN DrawBattleScreen DrawNeed%
        IF GoGo% THEN
        FOR I = 1 TO 2
            IF PlayerGo%(I) > 99 AND PlayerAlive%(I) THEN
                ChoiceBox 1
                HandY% = 5: HandX% = 10
                PUT (PlayerX%(I), PlayerY%(I)), Players%(514 * 6), AND
                PUT (HandX%, HandY%), Hand%(0), PSET
                ChoiceMade% = False

                DO
                    SELECT CASE INKEY$
                    CASE CHR$(0) + CHR$(72)
                        IF HandY% = 5 THEN
                                HandY% = 29
                            ELSEIF HandY% = 29 THEN
                                HandY% = 5
                        END IF
                        LINE (5, 7)-(24, 45), 0, BF
                        PUT (HandX%, HandY%), Hand%, PSET
                    CASE CHR$(0) + CHR$(80)
                        IF HandY% = 5 THEN
                                HandY% = 29
                            ELSEIF HandY% = 29 THEN
                                HandY% = 5
                        END IF
                        LINE (5, 7)-(24, 45), 0, BF
                        PUT (HandX%, HandY%), Hand%, PSET
                    CASE CHR$(13)
                        IF HandY% = 5 THEN
                                ChoiceBox 0
                                GetHandLocation
                                GET (HandX%, HandY%)-(HandX% + 15, HandY% + 15), BackHand%
                                PUT (HandX%, HandY%), Hand%(130), AND
                                PUT (HandX%, HandY%), Hand%(0), XOR
                                ChoiceMade2% = False
                                DO

                                    SELECT CASE INKEY$
                                    CASE CHR$(0) + CHR$(72), CHR$(0) + CHR$(80)
                                        PUT (HandX%, HandY%), BackHand%, PSET
                                        IF HandX% = 8 AND HandY% = 85 THEN
                                                IF EnemyAlive%(3) THEN
                                                        HandX% = 8: HandY% = 135
                                                    ELSEIF EnemyAlive%(4) THEN
                                                        HandX% = 114: HandY% = 135
                                                    ELSEIF EnemyAlive%(2) THEN
                                                        HandX% = 114: HandY% = 85
                                                END IF
                                            ELSEIF HandX% = 114 AND HandY% = 85 THEN
                                                IF EnemyAlive%(4) THEN
                                                        HandX% = 114: HandY% = 135
                                                    ELSEIF EnemyAlive%(3) THEN
                                                        HandX% = 8: HandY% = 135
                                                    ELSEIF EnemyAlive%(1) THEN
                                                        HandX% = 8: HandY% = 85
                                                END IF
                                            ELSEIF HandX% = 8 AND HandY% = 135 THEN
                                                IF EnemyAlive%(1) THEN
                                                        HandX% = 8: HandY% = 85
                                                    ELSEIF EnemyAlive%(2) THEN
                                                        HandX% = 114: HandY% = 85
                                                    ELSEIF EnemyAlive%(4) THEN
                                                        HandX% = 114: HandY% = 135
                                                END IF
                                            ELSEIF HandX% = 114 AND HandY% = 135 THEN
                                                IF EnemyAlive%(2) THEN
                                                        HandX% = 114: HandY% = 85
                                                    ELSEIF EnemyAlive%(1) THEN
                                                        HandX% = 8: HandY% = 85
                                                    ELSEIF EnemyAlive%(3) THEN
                                                        HandX% = 8: HandY% = 135
                                                END IF
                                        END IF
                                        GET (HandX%, HandY%)-(HandX% + 15, HandY% + 15), BackHand%
                                        PUT (HandX%, HandY%), Hand%(130), AND
                                        PUT (HandX%, HandY%), Hand%(0), XOR
                                    CASE CHR$(0) + CHR$(75), CHR$(0) + CHR$(77)
                                        PUT (HandX%, HandY%), BackHand%, PSET
                                        IF HandX% = 8 AND HandY% = 85 THEN
                                                IF EnemyAlive%(2) THEN
                                                        HandX% = 114: HandY% = 85
                                                    ELSEIF EnemyAlive%(4) THEN
                                                        HandX% = 114: HandY% = 135
                                                    ELSEIF EnemyAlive%(3) THEN
                                                        HandX% = 8: HandY% = 135
                                                END IF
                                            ELSEIF HandX% = 114 AND HandY% = 85 THEN
                                                IF EnemyAlive%(1) THEN
                                                        HandX% = 8: HandY% = 85
                                                    ELSEIF EnemyAlive%(3) THEN
                                                        HandX% = 8: HandY% = 135
                                                    ELSEIF EnemyAlive%(4) THEN
                                                        HandX% = 114: HandY% = 135
                                                END IF
                                            ELSEIF HandX% = 8 AND HandY% = 135 THEN
                                                IF EnemyAlive%(4) THEN
                                                        HandX% = 114: HandY% = 135
                                                    ELSEIF EnemyAlive%(2) THEN
                                                        HandX% = 114: HandY% = 85
                                                    ELSEIF EnemyAlive%(1) THEN
                                                        HandX% = 8: HandY% = 85
                                                END IF
                                            ELSEIF HandX% = 114 AND HandY% = 135 THEN
                                                IF EnemyAlive%(3) THEN
                                                        HandX% = 8: HandY% = 135
                                                    ELSEIF EnemyAlive%(1) THEN
                                                        HandX% = 8: HandY% = 85
                                                    ELSEIF EnemyAlive%(2) THEN
                                                        HandX% = 114: HandY% = 85
                                                END IF
                                        END IF
                                        GET (HandX%, HandY%)-(HandX% + 15, HandY% + 15), BackHand%
                                        PUT (HandX%, HandY%), Hand%(130), AND
                                        PUT (HandX%, HandY%), Hand%(0), XOR
                                    CASE CHR$(13)
                                        IF HandX% = 8 AND HandY% = 85 THEN
                                                EnemySelect% = 1
                                            ELSEIF HandX% = 114 AND HandY% = 85 THEN
                                                EnemySelect% = 2
                                            ELSEIF HandX% = 8 AND HandY% = 135 THEN
                                                EnemySelect% = 3
                                            ELSEIF HandX% = 114 AND HandY% = 135 THEN
                                                EnemySelect% = 4
                                        END IF
                                        ChoiceMade2% = True
                                    END SELECT
                                LOOP UNTIL ChoiceMade2%

                                Damage% = (PlayerST%(I) * 2 + INT(RND * 4) + 1) - EnemyDF%(EnemySelect%)
                                IF Damage% = 0 THEN Damage% = INT(RND * 2) + 1
                                EnemyHP%(EnemySelect%) = EnemyHP%(EnemySelect%) - Damage%
                                IF EnemyHP%(EnemySelect%) < 1 THEN EnemyAlive%(EnemySelect%) = False
                                FOR J = 7 TO 8
                                    PUT (PlayerX%(I), PlayerY%(I)), BackSprite%(514 * (I - 1)), PSET
                                    PUT (PlayerX%(I), PlayerY%(I)), Players%(514 * J), AND
                                    IF J = 7 THEN
                                            PUT (PlayerX%(I), PlayerY%(I)), Players%(514 * (PlayerType%(I) + 1)), XOR
                                        ELSEIF J = 8 THEN
                                            PUT (PlayerX%(I), PlayerY%(I)), Players%(514 * (PlayerType%(I) + 2)), XOR
                                    END IF
                                    TimerDelay .5
                                NEXT J
                                IF EnemySelect% = 1 THEN
                                        LOCATE 12, 4: PRINT USING "###"; Damage%
                                    ELSEIF EnemySelect% = 2 THEN
                                        LOCATE 12, 17: PRINT USING "###"; Damage%
                                    ELSEIF EnemySelect% = 3 THEN
                                        LOCATE 18, 4: PRINT USING "###"; Damage%
                                    ELSEIF EnemySelect% = 4 THEN
                                        LOCATE 18, 17: PRINT USING "###"; Damage%
                                END IF
                                TimerDelay 3
                                ChoiceMade% = True: DrawNeed% = 1
                            ELSEIF HandY% = 29 THEN
                                IF INT(RND * PlayerAG%(I)) + PlayerAG%(I) / 2 > INT(RND * EnemyAG%(I)) + EnemyAG%(I) / 2 THEN RanAway = True
                                ChoiceMade% = True
                        END IF
                    END SELECT
                LOOP UNTIL ChoiceMade%
                PlayerGo%(I) = 0: GoGo% = False
            END IF
        NEXT I
        END IF
        IF EnemyAlive%(1) = False AND EnemyAlive%(2) = False AND EnemyAlive%(3) = False AND EnemyAlive%(4) = False THEN
                Won = True
            ELSEIF PlayerAlive%(1) = False AND PlayerAlive%(2) = False THEN
                Lost = True
        END IF

        IF Lost = False AND Won = False AND RanAway = False THEN
                DrawBattleScreen DrawNeed%
            ELSE
                DrawBattleScreen 2
        END IF
        DrawNeed% = 0

    LOOP UNTIL Lost OR Won OR RanAway

    IF Lost THEN
            LOCATE 2, 2: PRINT "Annhiliated..."
        ELSEIF RanAway THEN
            LOCATE 2, 2: PRINT "You got away!"
        ELSEIF Won THEN
            LOCATE 2, 2: PRINT "Victory!"
            WHILE INKEY$ = "": WEND
            TotalEXP% = EnemyEXP%(1) + EnemyEXP%(2) + EnemyEXP%(3) + EnemyEXP%(4)
            FOR I = 1 TO 2
                IF PlayerAlive%(I) THEN PlayerEXP&(I) = PlayerEXP&(I) + TotalEXP%
            NEXT I
            DrawBattleScreen 2
            LOCATE 2, 2: PRINT "Gained"; TotalEXP%; "experience."
            WHILE INKEY$ = "": WEND
            TotalGold% = EnemyGold%(1) + EnemyGold%(2) + EnemyGold%(3) + EnemyGold%(4)
            DrawBattleScreen 2
            LOCATE 2, 2: PRINT "Gained"; TotalGold%; "gold."
    END IF
    WHILE INKEY$ = "": WEND

END SUB

SUB ChoiceBox (BoxType%)

    LINE (0, 0)-(120, 50), 23, B
    LINE (1, 1)-(119, 49), 25, B
    LINE (2, 2)-(118, 48), 24, B
    LINE (3, 3)-(117, 47), 0, BF

    IF BoxType% = 0 THEN
            IF EnemyAlive%(1) THEN
                LOCATE 2, 2: PRINT EnemyName$(1)
            END IF
            IF EnemyAlive%(2) THEN
                LOCATE 3, 2: PRINT EnemyName$(2)
            END IF
            IF EnemyAlive%(3) THEN
                LOCATE 4, 2: PRINT EnemyName$(3)
            END IF
            IF EnemyAlive%(4) THEN
                LOCATE 5, 2: PRINT EnemyName$(4)
            END IF
        ELSEIF BoxType% = 1 THEN
            LOCATE 2, 5: PRINT "ATTACK"
            LOCATE 5, 5: PRINT "RUN"
    END IF

END SUB

SUB DrawBattleScreen (ScreenType%)

    DEF SEG = &HA000
    IF ScreenType% = 0 THEN
            ChoiceBox 0
            StatsBox
        ELSEIF ScreenType% = 1 THEN
            BLOAD "back1.bsv"
            GET (PlayerX%(1), PlayerY%(1))-(PlayerX%(1) + 31, PlayerY%(1) + 31), BackSprite%(0)
            GET (PlayerX%(2), PlayerY%(2))-(PlayerX%(2) + 31, PlayerY%(2) + 31), BackSprite%(514)
            ChoiceBox 0
            StatsBox
        ELSEIF ScreenType% = 2 THEN
            BLOAD "back2.bsv"
    END IF
    DEF SEG

    IF ScreenType% < 2 THEN
        Yellow = PlayerGo%(1) + 128
        IF Yellow% > 228 THEN Yellow% = 228
        IF Yellow% > 128 THEN LINE (128, 16)-(Yellow%, 18), 44, BF
        IF Yellow% < 228 THEN LINE (Yellow% + 1, 16)-(228, 18), 40, BF
        Yellow = PlayerGo%(2) + 128
        IF Yellow% > 228 THEN Yellow% = 228
        IF Yellow% > 128 THEN LINE (128, 32)-(Yellow%, 34), 44, BF
        IF Yellow% < 228 THEN LINE (Yellow% + 1, 32)-(228, 34), 40, BF
    END IF

    FOR I = 1 TO 4
        IF EnemyAlive%(I) THEN
            PUT (EnemyX%(I), EnemyY%(I)), Enemies%(514 * 4), AND
            PUT (EnemyX%(I), EnemyY%(I)), Enemies%(514 * EnemyType%(I)), XOR
        END IF
    NEXT I

    FOR I = 1 TO 2
        IF PlayerAlive%(I) THEN
            PUT (PlayerX%(I), PlayerY%(I)), Players%(514 * 6), AND
            PUT (PlayerX%(I), PlayerY%(I)), Players%(514 * PlayerType%(I)), XOR
        END IF
    NEXT I

END SUB

SUB GetHandLocation

    IF EnemyAlive%(1) THEN
            HandX% = 8: HandY% = 85
        ELSEIF EnemyAlive%(2) THEN
            HandX% = 114: HandY% = 85
        ELSEIF EnemyAlive%(3) THEN
            HandX% = 8: HandY% = 135
        ELSEIF EnemyAlive%(4) THEN
            HandX% = 114: HandY% = 135
    END IF

END SUB

REM $DYNAMIC
SUB InitBattle

    FOR I = 1 TO 4
        EnemyType%(I) = INT(RND * 4)
        IF EnemyType%(I) = 0 THEN
                EnemyName$(I) = "Green Goblin"
                EnemyMaxHP%(I) = 20: EnemyMaxMP%(I) = 5
                EnemyST%(I) = 3: EnemyDF%(I) = 2: EnemyAG%(I) = 3
                EnemyMS%(I) = 1: EnemyMD%(I) = 3
                EnemyEXP%(I) = 10: EnemyGold%(I) = 4
                EnemyAlive%(I) = True
            ELSEIF EnemyType%(I) = 1 THEN
                EnemyName$(I) = "Blue Goblin"
                EnemyMaxHP%(I) = 20: EnemyMaxMP%(I) = 25
                EnemyST%(I) = 2: EnemyDF%(I) = 1: EnemyAG%(I) = 4
                EnemyMS%(I) = 5: EnemyMD%(I) = 4
                EnemyEXP%(I) = 14: EnemyGold%(I) = 6
                EnemyAlive%(I) = True
            ELSEIF EnemyType%(I) = 2 THEN
                EnemyName$(I) = "Orange Goblin"
                EnemyMaxHP%(I) = 40: EnemyMaxMP%(I) = 0
                EnemyST%(I) = 5: EnemyDF%(I) = 3: EnemyAG%(I) = 2
                EnemyMS%(I) = 1: EnemyMD%(I) = 1
                EnemyEXP%(I) = 18: EnemyGold%(I) = 10
                EnemyAlive%(I) = True
            ELSEIF EnemyType%(I) = 3 THEN
                EnemyName$(I) = "Purple Goblin"
                EnemyMaxHP%(I) = 25: EnemyMaxMP%(I) = 15
                EnemyST%(I) = 3: EnemyDF%(I) = 3: EnemyAG%(I) = 3
                EnemyMS%(I) = 3: EnemyMD%(I) = 3
                EnemyEXP%(I) = 16: EnemyGold%(I) = 8
                EnemyAlive%(I) = True
        END IF
        EnemyHP%(I) = EnemyMaxHP%(I): EnemyMP%(I) = EnemyMaxMP%(I)
    NEXT I

END SUB

SUB InitRandomStats

    PlayerName$(1) = "DarkDread": PlayerName$(2) = "Tyranny"
    PlayerAlive%(1) = True: PlayerAlive%(2) = True

    PlayerMaxHP%(1) = 52: PlayerMaxHP%(2) = 37
    PlayerMaxMP%(1) = 11: PlayerMaxMP%(2) = 31

    PlayerHP%(1) = PlayerMaxHP%(1): PlayerHP%(2) = PlayerMaxHP%(2)
    PlayerMP%(1) = PlayerMaxMP%(1): PlayerMP%(2) = PlayerMaxMP%(2)

    PlayerST%(1) = 7: PlayerST%(2) = 5
    PlayerDF%(1) = 4: PlayerDF%(2) = 0
    PlayerAG%(1) = 4: PlayerAG%(2) = 3
    PlayerMS%(1) = 4: PlayerMS%(2) = 8
    PlayerMD%(1) = 5: PlayerMD%(2) = 9

    EnemyX%(1) = 25: EnemyY%(1) = 75
    EnemyX%(2) = 125: EnemyY%(2) = 75
    EnemyX%(3) = 25: EnemyY%(3) = 125
    EnemyX%(4) = 125: EnemyY%(4) = 125

    PlayerX%(1) = 275: PlayerY%(1) = 75
    PlayerX%(2) = 275: PlayerY%(2) = 125

    PlayerType%(1) = 0: PlayerType%(2) = 3

END SUB

SUB InitSprites

    DEF SEG = VARSEG(Players%(0)): BLOAD "players.spr", VARPTR(Players%(0)): DEF SEG
    DEF SEG = VARSEG(Enemies%(0)): BLOAD "enemies.spr", VARPTR(Enemies%(0)): DEF SEG
    DEF SEG = VARSEG(Hand%(0)): BLOAD "handy.spr", VARPTR(Hand%(0)): DEF SEG

END SUB

REM $STATIC
SUB StatsBox

    LINE (121, 0)-(319, 50), 23, B
    LINE (122, 1)-(318, 49), 25, B
    LINE (123, 2)-(317, 48), 24, B
    LINE (124, 3)-(316, 47), 0, BF

    LOCATE 2, 17: PRINT PlayerName$(1)
    IF PlayerHP%(1) / PlayerMaxHP%(1) < .25 THEN COLOR 40
    LOCATE 2, 30: PRINT USING "HP ###/"; PlayerHP%(1)
    LOCATE 2, 37: PRINT USING "###"; PlayerMaxHP%(1)
    COLOR 47
    LOCATE 3, 30: PRINT USING "MP ###/"; PlayerMP%(1)
    LOCATE 3, 37: PRINT USING "###"; PlayerMaxMP%(1)
   
    COLOR 15
    LOCATE 4, 17: PRINT PlayerName$(2)
    IF PlayerHP%(2) / PlayerMaxHP%(2) < .25 THEN COLOR 40
    LOCATE 4, 30: PRINT USING "HP ###/"; PlayerHP%(2)
    LOCATE 4, 37: PRINT USING "###"; PlayerMaxHP%(2)
    COLOR 47
    LOCATE 5, 30: PRINT USING "MP ###/"; PlayerMP%(2)
    LOCATE 5, 37: PRINT USING "###"; PlayerMaxMP%(2)
    COLOR 15

END SUB

SUB TimerDelay (Seconds!)

    CurrentTime! = TIMER
    WHILE CurrentTime! + Seconds! > TIMER: WEND

END SUB

